from abc import ABC, abstractmethod
from enum import StrEnum
from typing import NamedTuple
import unittest

class Animal(ABC):
    def __init__(self,name,weight):
        self.__name = name
        self.__weight = weight
        self.__hungry = False

    @property 
    def name(self):
        return self.__name
    
    @name.setter
    def set_name(self,name):
        self.__name = name
        return self.__name
    
    @property
    def feed(self):
        if self.__hungry:
            self.__hungry = False
            return self.__hungry
        else:
            return "The Animal is not hungry"
        
    @property
    def starve(self):
        if self.__hungry:
            return "the Animal is already hungry"
        else:
            self.__hungry = True
            return self.__hungry
        
    @property
    def isHungry(self):
        if self.__hungry:
            return True
        else:
            return False
        
    @abstractmethod
    def sound(self):
        return "bark"    
        
        
class Dog (Animal):
    def __init__(self,name,weight):
        super().__init__(name,weight)
    
    @property
    def sound(self):
        return "bark"

    
class Direction (StrEnum):
    NORTH = "N"
    WEST = "W"
    EAST = "E"
    SOUTH = "S"
    
class Point(NamedTuple):
    x:int 
    y:int
    
class Address:
    def __init__(self, street_name, street_no, postal_code, city, country):
        self.street_name = street_name
        self.street_no = street_no
        self.postal_code = postal_code
        self.city = city
        self.country = country

    def __copy__(self):
        return Address(self.street_name, self.street_no, self.postal_code, self.city, self.country)

class Contact:
    def __init__(self, firstname, name, address, phone):
        self.firstname = first_name
        self.name = name
        self.address = address
        self.phone = phone

    def copy(self, deep_copy=False):
        if deep_copy:
            address_copy = Address(
                self.address.street_name,
                self.address.street_no,
                self.address.postal_code,
                self.address.city,
                self.address.country
            )
        else:
            address_copy = self.address
        
        return Contact(self.first_name, self.name, address_copy, self.phone)

    def __copy__(self):
        return self.copy(deep_copy=False)

    def getAddress():
        return self.address
    def getFirstname():
        return self.firstname
    def getName():
        return self.name
    def getPhone():
        return self.phone
    
    def setPhone(self,phone):
        self.phone = phone

    def setFirstname(self,firstname):
        self.firstname = firstname

    def setName(self,name):
        self.name = name
        
    def setAddress(self,address):
        self.address = address           
                        

def signe(nb):
    if  nb<0:
        return "negatif"
    elif nb == 0:
        return "null"
    else:
        return "positif"

def interval(nb1,nb2,nb3):
    if nb2 <= nb3:
        if nb1<nb2 or nb1>nb3:
            return False
        else:
            return True
    else:
        return False    
        
class testsigne(unittest.TestCase):
    def test_negatif(self):
        self.assertEqual(signe(-1), "negatif")

    def test_null(self):
        self.assertEqual(signe(0), "null")

    def test_positif(self):
        self.assertEqual(signe(1), "positif")
        
class intervaltest(unittest.TestCase):
    def test_inIt(self):
        self.assertEqual(interval(2,1,3),True)
        
    def test_ouIt(self):
        self.assertEqual(interval(1,2,3),False)              

if __name__ == '__main__':
    unittest.main()


